using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace M147
{
    public class M147
    {
        public static void Main()
        {

            CategoryBuilder.Create("ForTanks", "",ModAPI.LoadSprite("Icoon.png"));

          //BS-3
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"), //item to derive from
					NameOverride = "BS-3", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "BS-3 light cannon for light tanks.", //new item description
					CategoryOverride = ModAPI.FindCategory("ForTanks"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("bs3.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{

						//getting the FirearmBehaviour for later manipulation
						var firearm = Instance.GetComponent<FirearmBehaviour>();                    //ЕСЛИ ТЫ ЭТО ЧИТАЕШЬ, ТО ТЫ КРУТОЙ))

						//creating a custom cartridge for the gun
						Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); //load a copy of the cartridge
						customCartridge.name = "BS"; //set a name
						customCartridge.Damage *= 1.3f; //change the damage however you like
						customCartridge.StartSpeed *= 3.6f; //change the bullet velocity
						customCartridge.PenetrationRandomAngleMultiplier *= 0.28f; //change the accuracy when the bullet travels through an object
						customCartridge.Recoil *= 1.0f; //change the recoil
						customCartridge.ImpactForce *= 2.0f; //change how much the bullet pushes the target

						//set the cartridge to the FirearmBehaviour
						firearm.Cartridge = customCartridge;
						firearm.AutomaticFireInterval = 0.13f;
						firearm.InitialInaccuracy = 0.01f;
						firearm.barrelPosition = new Vector2(1.3f,0.01f);         //EXPLOSIVES

						//set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("bs1.mp3"),
							ModAPI.LoadSound("bs2.mp3"),
							ModAPI.LoadSound("bs3.mp3"),
						};
						//setting the sprite
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BS_3.png", 3f);
						// set the collision box to the new sprite shape
						// this is the easiest way to fix your collision shape, but it also the slowest.
						Instance.FixColliders();
					}
				}
			);
        //KT-28
      ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"), //item to derive from
					NameOverride = "KT-28", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "KT-28 very powerful, but not accurate.", //new item description
					CategoryOverride = ModAPI.FindCategory("ForTanks"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("kt28.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{

						//getting the FirearmBehaviour for later manipulation
						var firearm = Instance.GetComponent<FirearmBehaviour>();

						//creating a custom cartridge for the gun
						Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); //load a copy of the cartridge
						customCartridge.name = "BS76"; //set a name
						customCartridge.Damage *= 4.0f; //change the damage however you like
						customCartridge.StartSpeed *= 2.5f; //change the bullet velocity
						customCartridge.PenetrationRandomAngleMultiplier *= 3.0f; //change the accuracy when the bullet travels through an object
						customCartridge.Recoil *= 1.8f; //change the recoil
						customCartridge.ImpactForce *= 2.8f; //change how much the bullet pushes the target

						//set the cartridge to the FirearmBehaviour
						firearm.Cartridge = customCartridge;
						firearm.AutomaticFireInterval = 0.13f;
						firearm.InitialInaccuracy = 0.06f;
						firearm.barrelPosition = new Vector2(1.3f,0.01f);

						//set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("kt-281.mp3"),
							ModAPI.LoadSound("kt-282.mp3"),
							ModAPI.LoadSound("kt-283.mp3"),
						};
						//setting the sprite
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("kt_28.png", 2f);
						// set the collision box to the new sprite shape
						// this is the easiest way to fix your collision shape, but it also the slowest.
						Instance.FixColliders();
          }
        }
      );
      //DTT
      ModAPI.Register(
        new Modification()
        {
          OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
          NameOverride = "DT", //new item name with a suffix to assure it is globally unique
          DescriptionOverride = "Mashine gun for tanks.", //new item description
          CategoryOverride = ModAPI.FindCategory("ForTanks"), //new item category
          ThumbnailOverride = ModAPI.LoadSprite("ddt.png"), //new item thumbnail (relative path)
          AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
          {

            //getting the FirearmBehaviour for later manipulation
            var firearm = Instance.GetComponent<FirearmBehaviour>();

            //creating a custom cartridge for the gun
            Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); //load a copy of the cartridge
            customCartridge.name = "dt"; //set a name
            customCartridge.Damage *= 0.5f; //change the damage however you like
            customCartridge.StartSpeed *= 4.0f; //change the bullet velocity
            customCartridge.PenetrationRandomAngleMultiplier *= 2.0f; //change the accuracy when the bullet travels through an object
            customCartridge.Recoil *= 0.8f; //change the recoil
            customCartridge.ImpactForce *= 0.2f; //change how much the bullet pushes the target

            //set the cartridge to the FirearmBehaviour
            firearm.Cartridge = customCartridge;
            firearm.AutomaticFireInterval = 0.13f;
            firearm.InitialInaccuracy = 0.01f;
            firearm.barrelPosition = new Vector2(1.3f,0.01f);

            //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
            firearm.ShotSounds = new AudioClip[]
            {
              ModAPI.LoadSound("ddt1.mp3"),
              ModAPI.LoadSound("ddt2.mp3"),
              ModAPI.LoadSound("ddt3.mp3"),
            };
            //setting the sprite
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("dd_t.png", 2f);
            // set the collision box to the new sprite shape
            // this is the easiest way to fix your collision shape, but it also the slowest.
            Instance.FixColliders();
             }
           }
         );
        ModAPI.Register(
                 new Modification()
                 {
                     OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                     NameOverride = "BS-3 shell",
                     NameToOrderByOverride = "A",
                     DescriptionOverride = "Shell for BS-3 (37MM)",
                     CategoryOverride = ModAPI.FindCategory("ForTanks"),
                     ThumbnailOverride = ModAPI.LoadSprite("BS37_.png"),
                     AfterSpawn = (Instance) =>
                     {
                         Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BS37.png", 3f);
                         Instance.FixColliders();
                       }
             				}
             			);
                  ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                               NameOverride = "KT-28 shell",
                               NameToOrderByOverride = "A",
                               DescriptionOverride = "Shell for KT-28 (76MM)",
                               CategoryOverride = ModAPI.FindCategory("ForTanks"),
                               ThumbnailOverride = ModAPI.LoadSprite("BS76_.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BS-76.png", 2f);
                                  ExplosiveBehaviour explbehaviour = Instance.GetComponent(typeof(ExplosiveBehaviour)) as ExplosiveBehaviour;
                                   Instance.FixColliders();
                                 }
                       				}
                       			);
                            ModAPI.Register(
                                new Modification()
                                {
                                    OriginalItem = ModAPI.FindSpawnable("Bulletproof Sheet"),
                                    NameOverride = "Armor",
                                    DescriptionOverride = "Just armor",
                                    CategoryOverride = ModAPI.FindCategory("ForTanks"),
                                    ThumbnailOverride = ModAPI.LoadSprite("arm.png", 1f),
                                    AfterSpawn = (Instance) =>
                                    {
                                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("rmor.png", 1f);
                                        Instance.FixColliders();
                                      }
                            				}
                            			);
                                  ModAPI.Register(
                            				new Modification()
                            				{
                            					OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
                            					NameOverride = "M13C", //new item name with a suffix to assure it is globally unique
                            					DescriptionOverride = "drum gun. 3 shells in 1 drum.", //new item description
                            					CategoryOverride = ModAPI.FindCategory("ForTanks"), //new item category
                            					ThumbnailOverride = ModAPI.LoadSprite("m1.png"), //new item thumbnail (relative path)
                            					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                            					{

                            						//getting the FirearmBehaviour for later manipulation
                            						var firearm = Instance.GetComponent<FirearmBehaviour>();

                            						//creating a custom cartridge for the gun
                            						Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); //load a copy of the cartridge
                            						customCartridge.name = "M13"; //set a name
                            						customCartridge.Damage *= 1.0f; //change the damage however you like
                            						customCartridge.StartSpeed *= 1.2f; //change the bullet velocity
                            						customCartridge.PenetrationRandomAngleMultiplier *= 3.7f; //change the accuracy when the bullet travels through an object
                            						customCartridge.Recoil *= 1f; //change the recoil
                            						customCartridge.ImpactForce *= 0.8f; //change how much the bullet pushes the target

                            						//set the cartridge to the FirearmBehaviour
                            						firearm.Cartridge = customCartridge;
                            						firearm.AutomaticFireInterval = 0.7f;
                            						firearm.InitialInaccuracy = 0.1f;
                            						firearm.barrelPosition = new Vector2(1.3f,0.01f);

                            						//set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
                            						firearm.ShotSounds = new AudioClip[]
                            						{
                            							ModAPI.LoadSound("bs1.mp3"),     //221-188=33
                            						};
                            						//setting the sprite
                            						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("m13.png", 3f);
                            						// set the collision box to the new sprite shape
                            						// this is the easiest way to fix your collision shape, but it also the slowest.
                            						Instance.FixColliders();
                                      }
                            				}
                            			);
                                   ModAPI.Register(
                                           new Modification()
                                           {
                                               OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                                               NameOverride = "M13C Shell",
                                               NameToOrderByOverride = "A",
                                               DescriptionOverride = "Shell for M13C (37MM)",
                                               CategoryOverride = ModAPI.FindCategory("ForTanks"),
                                               ThumbnailOverride = ModAPI.LoadSprite("m13_.png"),
                                               AfterSpawn = (Instance) =>
                                               {
                                                   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("m1s.png", 3f);
                                                   Instance.FixColliders();
                                                 }
                                              }
                                           );
                                           ModAPI.Register(
                                     				new Modification()
                                     				{
                                     					OriginalItem = ModAPI.FindSpawnable("AK-47"), //item to derive from
                                     					NameOverride = "M152", //new item name with a suffix to assure it is globally unique
                                     					DescriptionOverride = "Mashine gun for tanks", //new item description
                                     					CategoryOverride = ModAPI.FindCategory("ForTanks"), //new item category
                                     					ThumbnailOverride = ModAPI.LoadSprite("M152_.png"), //new item thumbnail (relative path)
                                     					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                                     					{

                                     						//getting the FirearmBehaviour for later manipulation
                                     						var firearm = Instance.GetComponent<FirearmBehaviour>();

                                     						//creating a custom cartridge for the gun
                                     						Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); //load a copy of the cartridge
                                     						customCartridge.name = ".50 BMG"; //set a name
                                     						customCartridge.Damage *= 1f; //change the damage however you like
                                     						customCartridge.StartSpeed *= 4f; //change the bullet velocity
                                     						customCartridge.PenetrationRandomAngleMultiplier *= 2f; //change the accuracy when the bullet travels through an object
                                     						customCartridge.Recoil *= 0.8f; //change the recoil
                                     						customCartridge.ImpactForce *= 0.2f; //change how much the bullet pushes the target

                                     						//set the cartridge to the FirearmBehaviour
                                     						firearm.Cartridge = customCartridge;
                                     						firearm.AutomaticFireInterval = 0.18f;
                                     						firearm.InitialInaccuracy = 0.06f;
                                     						firearm.barrelPosition = new Vector2(1.3f,0.01f);

                                     						//set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
                                     						firearm.ShotSounds = new AudioClip[]
                                     						{
                                     							ModAPI.LoadSound("m1521.mp3"),
                                     						};
                                     						//setting the sprite
                                     						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("m152.png", 2f);
                                     						// set the collision box to the new sprite shape
                                     						// this is the easiest way to fix your collision shape, but it also the slowest.
                                     						Instance.FixColliders();
                            	                 	}
                            	                }
                                            );
                                            ModAPI.Register(
                                              new Modification()
                                              {
                                                OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"), //item to derive from
                                                NameOverride = "M8", //new item name with a suffix to assure it is globally unique
                                                DescriptionOverride = "M8 very powerful, but not accurate.", //new item description
                                                CategoryOverride = ModAPI.FindCategory("ForTanks"), //new item category
                                                ThumbnailOverride = ModAPI.LoadSprite("M8.png"), //new item thumbnail (relative path)
                                                AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                                                {

                                                  //getting the FirearmBehaviour for later manipulation
                                                  var firearm = Instance.GetComponent<FirearmBehaviour>();

                                                  //creating a custom cartridge for the gun
                                                  Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); //load a copy of the cartridge
                                                  customCartridge.name = "M66"; //set a name
                                                  customCartridge.Damage *= 4.0f; //change the damage however you like
                                                  customCartridge.StartSpeed *= 2.5f; //change the bullet velocity
                                                  customCartridge.PenetrationRandomAngleMultiplier *= 3.0f; //change the accuracy when the bullet travels through an object
                                                  customCartridge.Recoil *= 1.6f; //change the recoil
                                                  customCartridge.ImpactForce *= 1.1f; //change how much the bullet pushes the target

                                                  //set the cartridge to the FirearmBehaviour
                                                  firearm.Cartridge = customCartridge;
                                                  firearm.AutomaticFireInterval = 0.13f;
                                                  firearm.InitialInaccuracy = 0.06f;
                                                  firearm.barrelPosition = new Vector2(1.3f,0.01f);

                                                  //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
                                                  firearm.ShotSounds = new AudioClip[]
                                                  {
                                                    ModAPI.LoadSound("M888.mp3"),
                                                  };
                                                  //setting the sprite
                                                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MM8.png", 2f);
                                                  // set the collision box to the new sprite shape
                                                  // this is the easiest way to fix your collision shape, but it also the slowest.
                                                  Instance.FixColliders();
                                                }
                                              }
                                            );
                                            ModAPI.Register(
                                                    new Modification()
                                                    {
                                                        OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                                                        NameOverride = "M8 Shell",
                                                        NameToOrderByOverride = "A",
                                                        DescriptionOverride = "Shell for M8 (75MM)",
                                                        CategoryOverride = ModAPI.FindCategory("ForTanks"),
                                                        ThumbnailOverride = ModAPI.LoadSprite("m8_.png"),
                                                        AfterSpawn = (Instance) =>
                                                        {
                                                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("M8S.png", 2f);
                                                            Instance.FixColliders();
                                                          }
                                                				}
                                                			);
                                                                         ModAPI.Register(
                                                                            new Modification()
                                                                            {
                                                                              OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"), //item to derive from
                                                                              NameOverride = "L-11", //new item name with a suffix to assure it is globally unique
                                                                              DescriptionOverride = "A new model of a powerful tank gun. Good armor penetration and accuracy.", //new item description
                                                                              CategoryOverride = ModAPI.FindCategory("ForTanks"), //new item category
                                                                              ThumbnailOverride = ModAPI.LoadSprite("l-11zas.png"), //new item thumbnail (relative path)
                                                                              AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                                                                              {

                                                                                //getting the FirearmBehaviour for later manipulation
                                                                                var firearm = Instance.GetComponent<FirearmBehaviour>();

                                                                                //creating a custom cartridge for the gun
                                                                                Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); //load a copy of the cartridge
                                                                                customCartridge.name = "yy"; //set a name
                                                                                customCartridge.Damage *= 10.0f; //change the damage however you like
                                                                                customCartridge.StartSpeed *= 4.0f; //change the bullet velocity
                                                                                customCartridge.PenetrationRandomAngleMultiplier *= 1.0f; //change the accuracy when the bullet travels through an object
                                                                                customCartridge.Recoil *= 1.6f; //change the recoil
                                                                                customCartridge.ImpactForce *= 1.1f; //change how much the bullet pushes the target

                                                                                //set the cartridge to the FirearmBehaviour
                                                                                firearm.Cartridge = customCartridge;
                                                                                firearm.AutomaticFireInterval = 0.13f;
                                                                                firearm.InitialInaccuracy = 0.02f;
                                                                                firearm.barrelPosition = new Vector2(1.3f,0.01f);

                                                                                //set the new gun sounds. this is an array of AudioClips that is picked from at random when shot
                                                                                firearm.ShotSounds = new AudioClip[]
                                                                                {
                                                                                  ModAPI.LoadSound("l11z.mp3"),
                                                                                };
                                                                                //setting the sprite
                                                                                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("l11t.png", 2f);
                                                                                // set the collision box to the new sprite shape
                                                                                // this is the easiest way to fix your collision shape, but it also the slowest.
                                                                                Instance.FixColliders();
                                                                              }
                                                                            }
                                                                          );
                                                                          ModAPI.Register(
                                                                                  new Modification()
                                                                                  {
                                                                                      OriginalItem = ModAPI.FindSpawnable("Handgrenade"),     //НЕ РАБОТАЕИТ
                                                                                      NameOverride = "L-11 Shell",
                                                                                      NameToOrderByOverride = "A",
                                                                                      DescriptionOverride = "Shell for L-11 (76MM)",
                                                                                      CategoryOverride = ModAPI.FindCategory("ForTanks"),
                                                                                      ThumbnailOverride = ModAPI.LoadSprite("l11szas.png"),
                                                                                      AfterSpawn = (Instance) =>
                                                                                      {
                                                                                          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("l11st.png", 2f);
                                                                                          Instance.FixColliders();
                                                                                      }
                                                                                }
                                                                          );
                                                                          ModAPI.Register(
                                                                                  new Modification()
                                                                                  {
                                                                                      OriginalItem = ModAPI.FindSpawnable("Rod"),
                                                                                      NameOverride = "Seat",
                                                                                      NameToOrderByOverride = "A",
                                                                                      DescriptionOverride = "Seat.",
                                                                                      CategoryOverride = ModAPI.FindCategory("ForTanks"),
                                                                                      ThumbnailOverride = ModAPI.LoadSprite("seatzas.png"),
                                                                                      AfterSpawn = (Instance) =>
                                                                                      {
                                                                                          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("seatt.png", 1f);
                                                                                          Instance.FixColliders();
                                                                                        }
                                                                                     }
                                                                                  );
                                                                                  ModAPI.Register(
                                                                                          new Modification()
                                                                                          {
                                                                                              OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                                                                                              NameOverride = "Magazine for M152.",
                                                                                              NameToOrderByOverride = "A",
                                                                                              DescriptionOverride = "Magazine for M152.",
                                                                                              CategoryOverride = ModAPI.FindCategory("ForTanks"),
                                                                                              ThumbnailOverride = ModAPI.LoadSprite("dtmzas.png"),
                                                                                              AfterSpawn = (Instance) =>
                                                                                              {
                                                                                                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("m152mt.png", 2f);
                                                                                                  Instance.FixColliders();
                                                                                      }
                                                                                    }
                                                                                  );
                                                                                  ModAPI.Register(
                                                                                          new Modification()
                                                                                          {
                                                                                              OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                                                                                              NameOverride = "Magazine for DT.",
                                                                                              NameToOrderByOverride = "A",
                                                                                              DescriptionOverride = "Magazine for DT.",
                                                                                              CategoryOverride = ModAPI.FindCategory("ForTanks"),
                                                                                              ThumbnailOverride = ModAPI.LoadSprite("dttmzas.png"),
                                                                                              AfterSpawn = (Instance) =>
                                                                                              {
                                                                                                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("dtmt.png", 2f);
                                                                                                  Instance.FixColliders();
                                                                                      }
                                                                                    }
                                                                                  );
                                                                                  ModAPI.Register(
                                                                                          new Modification()
                                                                                          {
                                                                                              OriginalItem = ModAPI.FindSpawnable("Red Barrel"),
                                                                                              NameOverride = "Fuel tank",
                                                                                              NameToOrderByOverride = "A",
                                                                                              DescriptionOverride = "Fuel tank.",
                                                                                              CategoryOverride = ModAPI.FindCategory("ForTanks"),
                                                                                              ThumbnailOverride = ModAPI.LoadSprite("ftzas.png"),
                                                                                              AfterSpawn = (Instance) =>
                                                                                              {
                                                                                                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ftt.png", 1f);
                                                                                                  Instance.FixColliders();
                                                                                                }
                                                                                             }
                                                                                          );
                                                                    		}
                                                                    	}
                                                                    }
